//---------------------------------------------------------------------------
/*

Q:   Splash sreen?
A:  "sys_splash.h"   "utils".    
<code>
...
//    "UnitSplash"   "FormSplash"    "Image1"  
#include "sys_splash.h"
#include "UnitSplash.h"
const AnsiString guid = "My Cool Programm";//    ,    ctrl+shift+g  IDE;
...
// USEFORM("UnitSplash.cpp", FormSplash);   -  !!!
...
WINAPI WinMain(HINSTANCE, HINSTANCE, LPSTR, int)
{
	splash<TFormSplash> s(-1); //    close_splash()
//	splash<TFormSplash> s(-1,guid); //    close_splash(guid);
//	splash<TFormSplash> s(0); //   Application->MainForm
//	splash<TFormSplash> s(3000); //  3 
...
//   splash      "FormSplash"
//  "UnitSplash.cpp"
__fastcall TFormSplash::TFormSplash(TComponent* Owner)
	: TForm(Owner)
{
	FormRegion(Handle,Image1->Picture->Bitmap,clBlack,100); //     
	// bitmap   24- (! !)
...
</code>

xTrim 07.06.05

*/
//---------------------------------------------------------------------------
#ifndef sys_splashH
#define sys_splashH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <forms.hpp>

//---------------------------------------------------------------------------

void close_splash(AnsiString t = "")
{
	static AnsiString id("");
	if(id == "")
	{
		id = t;
		return;
	}
	HANDLE handle_ = OpenMutex(MUTEX_ALL_ACCESS, TRUE, id.c_str());
	ReleaseMutex(handle_);
	CloseHandle(handle_);
};

//---------------------------------------------------------------------------

template<class T> class splashImpl : public TThread
{
private:
	AnsiString pid_;
	T* form_;
	int sl_interval_;
	HANDLE handle_;
	bool can_close_;
	bool updated_;
	bool modal_;
	void __fastcall ShowForm()
	{
		if(!modal_)
			form_->Show();
		else
			form_->ShowModal();
		form_->Update();
	}
	void __fastcall CloseForm()
	{
		can_close_ = true;
		form_->Close();
	}

	void update_sleep(int var)
	{
		if(updated_)
		{
			form_->Update();
			updated_ = false;
		}
		Sleep(var);
	}

	void __fastcall Execute()
	{
		ShowForm();
		if(sl_interval_ > 0)
			update_sleep(sl_interval_);
		while(!Application)
			update_sleep(10);
		while(!Application->MainForm)
			update_sleep(10);
		while(Application->MainForm->Visible == false)
			update_sleep(10);
		if(sl_interval_ < 0)
		{
			if(sl_interval_ == -1)
			{
				HANDLE h = OpenMutex(MUTEX_ALL_ACCESS, TRUE, pid_.c_str());
				WaitForSingleObject(h, INFINITE);
			} else
				update_sleep(-sl_interval_);
		}
		CloseForm();
	}

	void __fastcall FormCloseQuery(TObject* Sender, bool& CanClose)
	{
		CanClose = can_close_;
	}

public:

	__fastcall splashImpl(int sl, AnsiString p, bool m)
		: TThread(false), sl_interval_(sl), pid_(p), modal_(m), can_close_(false),
		updated_(false)
	{
		form_ = new T(Application);
		form_->OnCloseQuery = FormCloseQuery;
		handle_ = CreateMutex(NULL, TRUE, pid_.c_str());
	}

	__fastcall ~splashImpl()
	{
		close_splash();
		ReleaseMutex(handle_);
		CloseHandle(handle_);
		if(form_ != 0)
			delete form_;
	}

	void can_close()
	{
		can_close_ = true;
	}

	T* get()
	{
		updated_ = true;
		return form_;
	}
};

//---------------------------------------------------------------------------

template<class T> class splash
{
private:
	splashImpl<T>* impl_;
	splash();
public:
	splash(int sl, AnsiString pid = "sys_unknown", bool m = false)
	{
		close_splash(pid + "_splash");
		impl_ = new splashImpl<T>(sl, pid + "_splash", m);
	}
	~splash()
	{
		delete impl_;
	}
	T* operator->()
	{
		return impl_->get();
	}
	T* operator()()
	{
		return impl_->get();
	}
	void can_close()
	{
		impl_->can_close();
	};
};

//---------------------------------------------------------------------------

void FormRegion(HWND Handle, Graphics::TBitmap* Bitmap, TColor TransparentColor,
	int Range)
{
	int x, y, FirstX;
	bool LastBeen;
	HRGN ComplexRGN, TempRGN;
	ComplexRGN = CreateRectRgn(0, 0, 0, 0);
	for(y = 0; y < Bitmap->Height; y++)
	{
		FirstX = 0;
		LastBeen = false;
		for(x = 0; x < Bitmap->Width; x++)
		{
			if((abs(Bitmap->Canvas->Pixels[x][y] - TransparentColor) > Range))
			{
				if(!LastBeen)
				{
					LastBeen = true;
					FirstX = x;
				}
			} else
			{
				if(LastBeen)
				{
					LastBeen = false; 	
					TempRGN = CreateRectRgn(FirstX, y, x, y + 1);
					CombineRgn(ComplexRGN, ComplexRGN, TempRGN, RGN_XOR);
					DeleteObject(TempRGN);
				}
			}
		}
	}
	SetWindowRgn(Handle, ComplexRGN, true);
	DeleteObject(ComplexRGN);
} 

//---------------------------------------------------------------------------
#endif
